//*****************************************************************************
//-----------------------------------------------------------------------------
// Function             : OpenCores IP spi_master test
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2013/11/08
//*****************************************************************************

#ifdef __hal__
  #include "sys/alt_stdio.h"
  #include <stdio.h>
  #include <stdlib.h>
  #include "system.h"
  // BASEADDR
  #define PWM0_BASEADDR   0x50000000
  #define PWM1_BASEADDR   0x50000010
  #define SPI_BASEADDR    0x50000100
  #define BRAM_BASEADDR   0x50001000
  // PRINT macro
  #define M_PRINT(str)  alt_putstr(str)
  #define M_PRINTF(str, ...) printf(str, __VA_ARGS__)
#elif __microblaze__
  #include <stdio.h>
  #include <stdlib.h>
  #include "platform.h"
  #include "xbasic_types.h"
  #include "XIOModule.h"
  // BASEADDR
  #define PWM0_BASEADDR   0xD0000000
  #define PWM1_BASEADDR   0xD0000010
  #define SPI_BASEADDR    0xD0000100
  #define BRAM_BASEADDR   0xC0001000
  // PRINT macro
  #define M_PRINT(str)  print(str)
  #define M_PRINTF(str, ...) xil_printf(str, __VA_ARGS__)
#endif

#define GPO      (*(volatile unsigned int *) PIO_0_BASE)
#define PWM0_CTRL (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x0))
#define PWM0_DIV  (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x2))
#define PWM0_PERIOD (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x4))
#define PWM0_DC (*(volatile unsigned short int *) (PWM0_BASEADDR + 0x6))

#define PWM1_CTRL (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x0))
#define PWM1_DIV  (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x2))
#define PWM1_PERIOD (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x4))
#define PWM1_DC (*(volatile unsigned short int *) (PWM1_BASEADDR + 0x6))

#define SPI_MASTER_CONTROL (*(volatile unsigned char *)(SPI_BASEADDR + 0x1))
#define SPI_TRANS_TYPE (*(volatile unsigned char *)(SPI_BASEADDR + 0x2))
#define SPI_TRANS_CTRL (*(volatile unsigned char *)(SPI_BASEADDR + 0x3))
#define SPI_TRANS_STS (*(volatile unsigned char *)(SPI_BASEADDR + 0x4))
#define SPI_TRANS_ERROR (*(volatile unsigned char *)(SPI_BASEADDR + 0x5))
#define SPI_DIRECT_ACCESS_DATA (*(volatile unsigned char *)(SPI_BASEADDR + 0x6))
#define SPI_SD_ADDR_7_0 (*(volatile unsigned char *)(SPI_BASEADDR + 0x7))
#define SPI_SD_ADDR_15_8 (*(volatile unsigned char *)(SPI_BASEADDR + 0x8))
#define SPI_SD_ADDR_23_16 (*(volatile unsigned char *)(SPI_BASEADDR + 0x9))
#define SPI_SD_ADDR_31_24 (*(volatile unsigned char *)(SPI_BASEADDR + 0xa))
#define SPI_CLK_DEL (*(volatile unsigned char *)(SPI_BASEADDR + 0xb))
#define SPI_RX_FIFO_DATA (*(volatile unsigned char *)(SPI_BASEADDR + 0x10))
#define SPI_RX_FIFO_DATA_COUNT_MSB (*(volatile unsigned char *)(SPI_BASEADDR + 0x12))
#define SPI_RX_FIFO_DATA_COUNT_LSB (*(volatile unsigned char *)(SPI_BASEADDR + 0x13))
#define SPI_RX_FIFO_CONTROL (*(volatile unsigned char *)(SPI_BASEADDR + 0x14))
#define SPI_TX_FIFO_DATA (*(volatile unsigned char *)(SPI_BASEADDR + 0x20))
#define SPI_TX_FIFO_CONTROL (*(volatile unsigned char *)(SPI_BASEADDR + 0x24))


#define IOBUS_REG_OFFSET    0x0


int str2int(char* adr_st )
{
	int adr;
	char tmp_st[5];
 	  tmp_st[0]=adr_st[0];
 	  tmp_st[1]=adr_st[1];
 	  tmp_st[2]=adr_st[2];
 	  tmp_st[3]=adr_st[3];
 	  tmp_st[4]='\0';
 	  adr = strtol(tmp_st,NULL,16) * 0x10000 ;
 	  tmp_st[0]=adr_st[4];
 	  tmp_st[1]=adr_st[5];
 	  tmp_st[2]=adr_st[6];
 	  tmp_st[3]=adr_st[7];
 	  tmp_st[4]='\0';
 	  adr = adr + strtol(tmp_st,NULL,16);
  return adr;
}

void adr_st_cp(char* in_st,char *tmp_st,int base )
{ //char * tmp_st;
    tmp_st[0]=in_st[base];
 	tmp_st[1]=in_st[base + 1];
 	tmp_st[2]=in_st[base + 2];
 	tmp_st[3]=in_st[base + 3];
 	tmp_st[4]=in_st[base + 4];
 	tmp_st[5]=in_st[base + 5];
 	tmp_st[6]=in_st[base + 6];
 	tmp_st[7]=in_st[base + 7];
 	tmp_st[8]='\0';
}
int keyinput_func (char* in_st,int lp, char data){
	//volatile char *in_st;
    int adr;
    //int adr_phy_mdio;
    int *adr_p;
    short *adr_short_p;
    char *adr_byte_p;
    char adr_st[9];
    //volatile char * adr_st;
    int dat;
    unsigned short dat_short;
    unsigned char dat_byte;
    char dat_st[10];
    //char hex_st[]="0123456789abcdef";
    //char *adr_st_p;
    volatile int lp_w;
    int cmd_hit;
    in_st[lp] = data;
     if (in_st[lp]!= '\n'){
    	lp++;
       }
     else{
       cmd_hit = 0;
	   in_st[lp + 1]='\0';
        // byete write
       if (in_st[lp-13]=='w'){
    	 adr_st_cp(in_st,adr_st,lp-12);
    	 adr= str2int(adr_st);
    	 dat_st[0]=in_st[lp-3];
    	 dat_st[1]=in_st[lp-2];
         dat_st[2]='\0';
         dat = strtol(dat_st,NULL,16);
         adr_byte_p = (char *)adr;
         *adr_byte_p = (char)dat;
         M_PRINTF("W1B ad= %x da=%02x \n" ,adr ,dat);
         //printf("W1B ad= %x da=%02x \n" ,adr,dat);
	     cmd_hit = 1;
    	 }
       // 2byte write
       if ((lp==16)&&(in_st[lp-16]=='w')&&(in_st[lp-15]=='w')){
         adr_st_cp(in_st,adr_st,lp-14);
         adr= str2int(adr_st);
         dat_st[0]=in_st[lp-5];
         dat_st[1]=in_st[lp-4];
         dat_st[2]=in_st[lp-3];
         dat_st[3]=in_st[lp-2];
         dat_st[4]='\0';
         dat = strtol(dat_st,NULL,16);
         adr_short_p = (short *)adr;
         *adr_short_p = (short)dat;
         M_PRINTF("W2B ad= %x da=%04x \n" ,adr,dat);
	     cmd_hit = 1;
         }
       // 4byte write
       if ((lp==19)&&(in_st[lp-19]=='W')){
         adr_st_cp(in_st,adr_st,lp-18);
         adr= str2int(adr_st);
         dat_st[0]=in_st[lp-9];
         dat_st[1]=in_st[lp-8];
         dat_st[2]=in_st[lp-7];
         dat_st[3]=in_st[lp-6];
         dat_st[4]=in_st[lp-5];
         dat_st[5]=in_st[lp-4];
         dat_st[6]=in_st[lp-3];
         dat_st[7]=in_st[lp-2];
         dat_st[8]='\0';
         dat= str2int(dat_st);
         adr_p = (int *)adr;
         *adr_p = dat;
         M_PRINTF("W4B ad= %x da=%08x \n" ,adr,dat);
	     cmd_hit = 1;
         }
    // 4bytes Read
    if (in_st[lp-10]=='R'){
         adr_st_cp(in_st,adr_st,lp-9);
         adr= str2int(adr_st);
         adr_p = (int *)adr;
         dat = *adr_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //M_PRINTF("\n");
         M_PRINTF("R4B ad= %x da=%08x \n" ,adr,dat);
	     cmd_hit = 1;
      }
    // 2bytes Read
    if ((in_st[lp-10]=='r')&&(in_st[lp-11]=='r')){
         adr_st_cp(in_st,adr_st,lp-9);
         adr= str2int(adr_st);
         adr_short_p = (short *)adr;
         dat_short = *adr_short_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //M_PRINTF("\n")
         M_PRINTF("R2B ad= %x da=%04x \n" ,adr,dat_short);
	     cmd_hit = 1;
      }
    // 1bytes Read
    if (in_st[lp-10]=='r'){
         adr_st_cp(in_st,adr_st,lp-9);
         adr= str2int(adr_st);
         adr_byte_p = (char *)adr;
         dat_byte = *adr_byte_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //M_PRINTF("\n");
         M_PRINTF("R1B ad= %x da=%02x \n" ,adr,dat_byte);
	     cmd_hit = 1;
      }
    // S cmd
    if (in_st[lp-2]=='S'){
	     M_PRINT("S\n");
         cmd_hit = 1;
	   }
    if (cmd_hit == 0)
	   	 M_PRINT("invalid command\n");
    lp = 0;
    M_PRINT(">");
    }
	return( lp );
}

//ubN[h֐
void read_block ( unsigned int sd_adr, unsigned int mem_adr)
{
  int i;
  int j;
  unsigned int rd_data;
  unsigned char data_tmp[4];
  M_PRINTF("sd block read adr %8x -> mem adr %8x\n",sd_adr,mem_adr);
  SPI_RX_FIFO_CONTROL =0x1;
  //AhXZbg
  SPI_SD_ADDR_7_0 = 0xff & sd_adr;
  SPI_SD_ADDR_15_8 = (0xff00 & sd_adr)>>8;
  SPI_SD_ADDR_23_16 = (0xff0000 & sd_adr)>>16;
  SPI_SD_ADDR_31_24 = (0xff000000 & sd_adr)>>24;
  SPI_TRANS_TYPE  = 0x2; //Block Read
  SPI_TRANS_CTRL  = 0x1; //Trans Start
  //]҂
  while(SPI_TRANS_STS==1);
  M_PRINTF("ERR= %x\n",SPI_TRANS_ERROR);
  //IPFIFO1byteǂݎ̂
  //data_tmp[0]=SPI_RX_FIFO_DATA;
  //IPFIFO512byteǂݍ
  for(i=0;i<=127;i++){
  rd_data =0;
  M_PRINTF("%3x ",i*4);
  for(j=0;j<=3;j++){
	//FIFO1byteǂݍ
    data_tmp[j]=SPI_RX_FIFO_DATA;
    //ǂݏof[^\
    M_PRINTF("%2x ",data_tmp[j]);
  }
  for(j=3;j>=0;j--){
	//4byef[^gݗ
    rd_data = (rd_data<<8) + data_tmp[j];
  }
    //4Bytef[^ubNRAM֏
    (*(volatile unsigned int *) (mem_adr + (i*4 ))) = rd_data;
    //ǂݏof[^LN^ŕ\
    for(j=0;j<=3;j++){
      if ((data_tmp[j]<0x20)||((data_tmp[j]>=0x80)&&(data_tmp[j]<0xa0)))
    	M_PRINT(".");
      else
	    M_PRINTF("%c",data_tmp[j]);
    }
    M_PRINT("\n");
 }
}


//ubNCg֐
void write_block ( unsigned int sd_adr, unsigned int mem_adr)
{
  int i;
  int j;
  unsigned int mem_data;
  unsigned char data_tmp[4];
  M_PRINTF("sd block write adr %8x <- mem adr %8x\n",sd_adr,mem_adr);
  SPI_TX_FIFO_CONTROL =0x1;
  //ubNRAM̃f[^512BytesIPFIFO֏
  for(i=0;i<=127;i++){
    mem_data =(*(unsigned int *) (BRAM_BASEADDR + i*4 ));
    M_PRINTF("%3x ",i*4);
    for(j=0;j<=3;j++){
	  data_tmp[j] = mem_data & 0xff;
	  mem_data = mem_data>>8;
	  SPI_TX_FIFO_DATA = data_tmp[j];
	 //݃f[^\
      M_PRINTF("%2x ",data_tmp[j]);
    }
	//݃f[^LN^ŕ\
    for(j=0;j<=3;j++){
      if ((data_tmp[j]<0x20)||((data_tmp[j]>=0x80)&&(data_tmp[j]<0xa0)))
    	M_PRINT(".");
      else
	    M_PRINTF("%c",data_tmp[j]);
    }
    M_PRINT("\n");
  }
  //M_PRINTF("w start ERR= %x\n",SPI_TRANS_ERROR);
  //AhXZbg
  SPI_SD_ADDR_7_0 = 0xff & sd_adr;
  SPI_SD_ADDR_15_8 = (0xff00 & sd_adr)>>8;
  SPI_SD_ADDR_23_16 = (0xff0000 & sd_adr)>>16;
  SPI_SD_ADDR_31_24 = (0xff000000 & sd_adr)>>24;
  SPI_TRANS_TYPE  = 0x3; //Block write
  SPI_TRANS_CTRL  = 0x1; //Trans Start
  //]҂
  while(SPI_TRANS_STS==1);
    M_PRINTF("w end ERR= %x\n",SPI_TRANS_ERROR);
}

//擪0x0̃f[^0ԃZN^̃AhX߂֐
unsigned int first_sector_adr ()
{
  unsigned int adr;
  read_block(0,BRAM_BASEADDR);
  adr = (  (*(unsigned char *) (BRAM_BASEADDR + 0x1c6))
		 + (*(unsigned char *) (BRAM_BASEADDR + 0x1c7))*256
		 + (*(unsigned char *) (BRAM_BASEADDR + 0x1c8))*65536
		 + (*(unsigned char *) (BRAM_BASEADDR + 0x1c9))*16777216)*512;
  M_PRINTF("first sector adr = %8x \n",adr);
  return adr;
}

//0ŃZN^̃f[^fBNgJnAhX߂
unsigned int dir_sector_adr ( unsigned int adr )
{
	  unsigned int dir_sct;
	  unsigned int dir_adr;
	  read_block(adr,BRAM_BASEADDR);
	  dir_sct =   (((*(unsigned char *) (BRAM_BASEADDR + 0xe))+(*(unsigned char *) (BRAM_BASEADDR + 0xf))*256) +
	            ((*(unsigned char *) (BRAM_BASEADDR + 0x10)) *
	             ((*(unsigned char *) (BRAM_BASEADDR + 0x16))+(*(unsigned char *) (BRAM_BASEADDR + 0x17))*256)));
	  M_PRINTF("dir_sector = %8x \n",dir_sct);
	  dir_adr = adr + dir_sct*512;
	  M_PRINTF("dir adr = %8x \n",dir_adr);
	  return dir_adr;
}

unsigned int dat_sector_adr ( unsigned int adr )
{
	  unsigned int dir_sct;
	  unsigned int dat_sct;
	  unsigned int dat_adr;
	  read_block(adr,BRAM_BASEADDR);
	  dir_sct =   (((*(unsigned char *) (BRAM_BASEADDR + 0xe))+(*(unsigned char *) (BRAM_BASEADDR + 0xf))*256) +
	            ((*(unsigned char *) (BRAM_BASEADDR + 0x10)) *
	             ((*(unsigned char *) (BRAM_BASEADDR + 0x16))+(*(unsigned char *) (BRAM_BASEADDR + 0x17))*256)));
	  M_PRINTF("dir_sector = %8x \n",dir_sct);
	  dat_sct = dir_sct + (((*(unsigned char *) (BRAM_BASEADDR + 0x11))+(*(unsigned char *) (BRAM_BASEADDR + 0x12))*256)/16);
	  dat_adr = adr + dat_sct*512;
	  M_PRINTF("dat_sector = %8x \n",dat_sct);
	  M_PRINTF("dat adr = %8x \n",dat_adr);
	  return dat_adr;
}

int main()
{
  unsigned int first_adr;
  unsigned int dir_adr;
  unsigned int dat_adr;
  unsigned int w_p;
  unsigned char dat;
  u32 uDevId = XPAR_IOMODULE_0_DEVICE_ID; //x
  volatile int lp;
  //u32 data;
  volatile int in_data;
  XIOModule NfdsIOMdule; //x
  u8 rx_buf[10];
  char in_st[32];
  init_platform(); //x
  XIOModule_Initialize(&NfdsIOMdule, uDevId); //x
  M_PRINT("start\n");
  lp =0;
  //PWM0 10uS Duty Hi:50% Low:50%
  PWM0_DIV = 100;
  PWM0_PERIOD = 100;
  PWM0_DC =      50;
  //PWM1 100uS Duty Hi:5% Low:95%
  PWM1_DIV = 100;
  PWM1_PERIOD = 100;
  PWM1_DC =       5;
  //PWM start
  PWM0_CTRL = 0x1e;     //start
  PWM1_CTRL = 0x1e;     //start
  //OpenCores SPI@̏
  SPI_TRANS_TYPE  = 0x1; //INIT_SD
  SPI_TRANS_CTRL  = 0x1; //Trans Start
  //̊҂
  while(SPI_TRANS_STS==1);
  //
  M_PRINTF("Init ERR= %x\n",SPI_TRANS_ERROR);
  M_PRINTF("s1 ERR= %x\n",SPI_TRANS_ERROR);
  //0x0ԒñZN^ǂݏoāAZN^0̔Ԓn߂
  first_adr = first_sector_adr ();
  //ZN^0fBNg̔Ԓn߂
  dir_adr = dir_sector_adr (first_adr);
  //fBNg\
  read_block( dir_adr,BRAM_BASEADDR);
  //ZN^0f[^Jn̔Ԓn߂
  dat_adr = dat_sector_adr (first_adr);
  M_PRINT("data\n");
  //ubN[h@SDJ[hdat_adr512BytesubNRAMփRs[
  read_block( dat_adr,BRAM_BASEADDR);
  //ubNRAM̃f[^
  for(w_p=0;w_p<24;w_p++){ //24Ώ
	dat = (*(unsigned char *) ( BRAM_BASEADDR + w_p)); //ubNRAMǂݏo
    if (dat > 0x40) //At@xbg̏ꍇ
	  if(dat > 0x60) //̏ꍇ
        dat = dat - 0x20; //啶ɕϊ
	  else //啶̏ꍇ
	    dat = dat + 0x20; //ɕϊ
    (*(unsigned char *) ( BRAM_BASEADDR + w_p)) = dat; //ubNRAM֏
  }
  //ubNCg@ubNRAM̐擪512bytesSDJ[h0x500000փRs[
  write_block( dat_adr,BRAM_BASEADDR);
  //mF߁AēxubN[h
  read_block( dat_adr,BRAM_BASEADDR);

  M_PRINT("\n>");

  while (1){

#ifdef __hal__

	  in_data = alt_getchar();
      M_PRINTF("%c",((char)in_data));
      //for(lp=0;lp<100000;lp++);
      lp = keyinput_func(in_st,lp,((char) in_data));

#elif __microblaze__

      if ((in_data = XIOModule_Recv(&NfdsIOMdule, rx_buf, 1)) != 0){
    	  XIOModule_Send(&NfdsIOMdule, &rx_buf[0],1);
          lp = keyinput_func(in_st,lp,rx_buf[0]);
      }
#endif
  }
  return 0;
}

