`timescale 1ns / 1ps
//*****************************************************************************
// File Name            : mb_mcs_sys.v
//-----------------------------------------------------------------------------
// Function             : MicroBlaze sd_card system test 
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2014/01/23
//*****************************************************************************


module test_mb_mcs_sys;

        // Inputs
        reg Clk;
        reg Reset;
        reg UART_Rx;
        reg [3:0] dip_sw;
        reg  miso ; //spi master input data

        // Outputs
        wire UART_Tx;
        wire [3:0] led;
        wire sclk ; //spi clk
        wire mosi ; //spi master output data
        wire ss ;   //spi select

        // Instantiate the Unit Under Test (UUT)
        mb_mcs_sys uut (
                .Clk(Clk), 
                .Reset(Reset), 
                .UART_Rx(UART_Rx), 
                .UART_Tx(UART_Tx), 
                .led(led), 
                .dip_sw(dip_sw),
                .sclk(sclk),
                .mosi(mosi),
                .miso(miso),
                .ss(ss)
        );

        initial begin
                // Initialize Inputs
                repeat(100000)begin
                  Clk = 0;
                  #5;
                  Clk = 1;
                  #5;
                  end
                $stop;
        end
 
 
        initial begin
                // Initialize Inputs
                Reset = 1;
                UART_Rx = 0;
                dip_sw = 0;
                miso = 1;

                // Wait 100 ns for global reset to finish
                #100;
                Reset = 0;        
                // Add stimulus here
        end
endmodule

